# -*- coding: utf-8 -*-

"""
Функция разворачивает чек на позиции, ищет товар в позиции в переданном функции каталоге
и, если товар найден, то устанавливает цену из каталога. 
Возвращают словарь из номеров позиций в качестве ключей
и суммы скидки в качестве значений для единицы товара.
"""

def catalogGoods(self, catalogid):
    result = {}
    tmcs = {}

    #Собираем список позиций, состоящих в указанном каталоге
    for item in self.checkWrapper.getGoodsList():
        for catalog in item.data["tmc"]["catalogs"]:
            if catalog["catalogid"] == catalogid:
                itemData = tmcs.setdefault(item.data['tmc']['code'], [catalog, 0.0, []])
                itemData[1] += item.data["bquant"]
                itemData[2].append(item)
                break

    def sortFunction(position):
        return position.data["price"]
    def notNone(value, default):
        return default if value is None else value

    for item in tmcs.values():
        catalog = item[0]
        totalAmount = int(item[1] + 0.0005)
        if totalAmount < max(notNone(catalog.get("mincount"), 0), notNone(catalog.get("multiplicity"), 0)):
            continue
        catalogPrice = catalog.get("tmcprice")
        catalogDiscount = catalog.get("percentdiscount")
        if catalogDiscount is None:
            if catalogPrice is None:
                continue
        else:
            catalogDiscount *= 0.01

        catalogMultiplicity = catalog.get("multiplicity")
        catalogMaxCount = notNone(catalog.get("maxcount"), 9999999999)
        if catalogMultiplicity is not None:
            catalogMaxCount = min(totalAmount, catalogMaxCount) // catalogMultiplicity * catalogMultiplicity
        #Дальше оно используется как дробное
        catalogMaxCount = float(catalogMaxCount)
        amount = 0.0
        #Сортируем от дешёвых к дорогим, чтобы давать скидку на дешёвые в приоритете
        item[2].sort(reverse=False, key=sortFunction)

        for position in item[2]:
            goodsAffected = min(position.data["bquant"], catalogMaxCount - amount)
            if goodsAffected < 0.001:
                break
            amount += goodsAffected
            if catalogPrice is None:
                discount = position.data["price"] * catalogDiscount
            elif catalogDiscount is None:
                discount = position.data["price"] - catalogPrice
            else:
                #Даём наибольшую скидку из настроеных
                discount = max(position.data["price"] - catalogPrice, position.data["price"] * catalogDiscount)
            result[position.data["posnum"]] = discount * goodsAffected

    return result
