# -*- coding: utf-8 -*-

from artixds.objectdiscount import DiscountObject

class KitObjectItem(object):
    '''
    Элемент набора
    '''
    def __init__(self, catalogCodes=None, quantity=1, name=None):
        self.catalogCodes = [] if catalogCodes is None else catalogCodes
        self.name = name
        self.quantity = quantity

    def __repr__(self): 
        return "KitObjectItem(catalogCodes=%s,quantity=%f,codes=%s)" % (self.catalogCodes, self.quantity, getattr(self, 'codes') if hasattr(self, 'codes') else set())

    def __eq__(self, other):
        if not other:
            return False
        return self.catalogCodes == other.catalogCodes and self.quantity == other.quantity and self.name == other.name

class KitObject(DiscountObject):
    '''
    Новый объект набора
    '''
    def __init__(self, items=None, id=None, name=None, maxtimes=None, byTmc=None, cartesian=None):
        self.items = [] if items is None else items
        self.id = id
        self.name = name
        self.maxtimes = maxtimes
        self.byTmc = byTmc
        self.cartesian = cartesian

    def __iter__(self):
        for item in self.items:
            yield item

    def __len__(self):
        return len(self.items)

    def __repr__(self):
        return "KitObject(maxtime=%s,items=%s,byTmc=%s,cartesian=%s)" % (self.maxtimes, self.items, self.byTmc, self.cartesian)

